%/***************************************************************************
% *   Copyright (C) 2010 by Kamaledin Ghiasi-Shirazi                        *
% *   ghiathi@gmail.com                                                     *
% *                                                                         *
% *   This program is free software; you can redistribute it and/or modify  *
% *   it under the terms of the GNU General Public License as published by  *
% *   the Free Software Foundation; either version 3 of the License, or     *
% *   (at your option) any later version.                                   *
% *                                                                         *
% *   This program is distributed in the hope that it will be useful,       *
% *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
% *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
% *   GNU General Public License for more details.                          *
% *                                                                         *
% *   You should have received a copy of the GNU General Public License     *
% *   along with this program; if not, write to the                         *
% *   Free Software Foundation, Inc.,                                       *
% *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
% ***************************************************************************/

function  [bestVal] = FindBestGammas_Stabilizer (cTotalIter, cRepeated, bestUptoNow)
global trn Gamma startPoints Beta Gamma_norm lmbfgs_max_iters lmbfgs_M  cteta steta  

start_time = clock;

R = sqrt (log(4 / bestUptoNow) / Beta);

if ~isreal (R)
    disp ('Error: R must be real.');
end

max_count = 0;
max_points = [];
bestVal = 0;
totalIter = 1;
repeated = 0; 
trn.active_features = 1:trn.dim;
trn.active_n = trn.dim;
cSmallBumps = 0;
allGammas = [];
gamma(1,:) = zeros (1,trn.dim);

totalIter = 1;
while (totalIter < cTotalIter && repeated < cRepeated + max_count)
    totalIter = totalIter + 2;
    
            %parfor parRepeated=1:2
            for parRepeated=1:2
                point = 2 *rand (trn.active_features_count, 1) - 1.0;
                point = point / norm(point, Gamma_norm) * R * rand();
                [gamma(parRepeated,trn.active_features) fval(parRepeated)]  = liblbfgsInterface (trn.X, trn.active_features, point, trn.sample_weights,...
                 trn.active_samples, Gamma_norm, Beta, lmbfgs_max_iters, lmbfgs_M ,cteta, steta, 0.00001, 0, 0.00001);
            end
            
            for repeated2=1:2
                if (-fval(repeated2) < 0.98 * bestUptoNow)
                    cSmallBumps = cSmallBumps + 1;
                    continue;
                end
                [ignore, idx] = max (abs (gamma(repeated2,:)));
                if (size(idx,2) > 0)
                    if (gamma(repeated2,idx(1)) < 0)
                        gamma (repeated2, :) = - gamma (repeated2, :);
                    end

                    idx = FindRepeatedMax(gamma(repeated2,:), max_points, max_count);

                    if (idx == 0)
                        max_count = max_count + 1;
                        max_points (max_count, 1) = fval(repeated2);
                        max_points (max_count, 2:trn.dim+1) = gamma(repeated2,:)';
                    else
                        repeated = repeated + 1;
                    end

                    if (fval(repeated2) < bestVal)
                        bestVal = fval(repeated2);
                    end
                end
            end
end

Gammas2 = sortrows (max_points);
Gammas2 = Gammas2 (1:min(size(Gammas2,1),500),:);

if (size(Gammas2,1) > 0)
    Gamma = Gammas2(:,2:trn.dim+1);
else
    %ME = MException('FindBestGammas_Stabilizer', 'Gamma = []');
    %throw(ME);
    Gamma = [];
end

%sprintf ('FindBestGammas_Stabilizer found m=%i points', size(Gamma,1))
%sprintf ('FindBestGammas_Stabilizer finished after %8.3f seconds',  etime(clock,start_time))
end

function idx = FindRepeatedMax(point, max_points, max_count)
    idx = 0;
    nplus1 = size(max_points,2);
    for i=1:max_count
        if (norm (point - max_points(i,2:nplus1),inf) < 0.01)
            idx = i;
            break;
        end
    end
end

