%/***************************************************************************
% *   Copyright (C) 2010 by Kamaledin Ghiasi-Shirazi                        *
% *   ghiathi@gmail.com                                                     *
% *                                                                         *
% *   This program is free software; you can redistribute it and/or modify  *
% *   it under the terms of the GNU General Public License as published by  *
% *   the Free Software Foundation; either version 3 of the License, or     *
% *   (at your option) any later version.                                   *
% *                                                                         *
% *   This program is distributed in the hope that it will be useful,       *
% *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
% *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
% *   GNU General Public License for more details.                          *
% *                                                                         *
% *   You should have received a copy of the GNU General Public License     *
% *   along with this program; if not, write to the                         *
% *   Free Software Foundation, Inc.,                                       *
% *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
% ***************************************************************************/

function  [bestVal] = FindBestInvSigma2sIsotropic (cTotalIter, cRepeated, bestUptoNow)
global trn InvSigma2 lmbfgs_max_iters lmbfgs_M  D2trn Eta

max_sigma = 30;
max_count = 0;
max_points = [];
bestVal = 0;
totalIter = 0;
repeated = 0; 
trn.active_features = 1:trn.dim;
trn.active_n = trn.dim;
cSmallBumps = 0;
gamma(1,:) = zeros (1,trn.dim);

%options = optimset('LargeScale','off','Hessian','off','display', 'off','GradObj', 'on','HessUpdate','bfgs', 'MaxIter', 10000, 'LineSearchType', 'quadcubic', 'UseParallel','always', 'DerivativeCheck', 'off');
% z=0;
% for i=1:100
%          point = i/5;
%          [z(i)] = -2 * subproblem_product_objective(double(D2trn (trn.active_samples,trn.active_samples,:)),[point; point],trn.sample_weights') ...
%                 * exp (-Eta * point * point);
% end
% 
% plot (0.2:0.2:20,z);
% startPoints = InvSigma2;
% ptr = size (startPoints,1);
% for i=1:cTotalIter
%     point = rand (trn.active_features_count, 1);
%     ptr = ptr + 1;    
%     startPoints (ptr,:) = point / norm(point) * rand() * max_sigma;
% end    


totalIter = 0;
allPoints=[];
apc = 0;   % all points count

while (totalIter < cTotalIter && repeated < cRepeated)
    totalIter = totalIter + 1;
     
            %   parfor parRepeated=1:2
            for parRepeated=1:1
            %   point = startPoints (totalIter,:)';
                
                point = rand ();
                point = point / norm(point) * rand() * max_sigma * 0.1;             

                [optPoint fval(parRepeated)] = ... 
                       LbfgsMaximizeWrtSigmaIsotropic(D2trn (trn.active_samples,trn.active_samples), point, trn.sample_weights', lmbfgs_max_iters, lmbfgs_M, Eta);
                   
                sigma(parRepeated) = optPoint;
                apc = apc + 1;
                allPoints (apc, 1) = fval(parRepeated);
                allPoints (apc, 2:trn.dim+1) = sigma(parRepeated)';
            end
            %fval
            %[norm(sigma(1,:)) norm(sigma(2,:))]
            
            %allInvSigma2s = [allInvSigma2s; sigma];
            %sigma = round(sigma * 10000) / 10000;            
            for repeated2=1:1
                if (-fval(repeated2) < bestUptoNow * 0.98)
                    cSmallBumps = cSmallBumps + 1;
                    continue;
                end
                [ignore, idx] = max (abs (sigma(repeated2)));
                if (size(idx,2) > 0)
                    if (sigma(repeated2) < 0)
                        sigma (repeated2) = - sigma (repeated2);
                    end

                    idx = FindRepeatedMax(sigma(repeated2), max_points, max_count);

                    if (idx == 0)
                        max_count = max_count + 1;
                        max_points (max_count, 1) = fval(repeated2);
                        max_points (max_count, 2) = sigma(repeated2)';
                    else
                        repeated = repeated + 1;
                    end

                    if (fval(repeated2) < bestVal)
                        bestVal = fval(repeated2);
                    end
                else
                    repeated = 1;
                end
            end    
end

if  (numel (max_points) == 0)
    allPoints
end
InvSigma2s2 = sortrows (max_points);
InvSigma2s2 = InvSigma2s2 (1:min(size(InvSigma2s2,1),500),:);

if (size(InvSigma2s2,1) > 0)
    InvSigma2 = InvSigma2s2(:,2);
else
    %ME = MException('FindBestInvSigma2s_Stabilizer', 'InvSigma2 = []');
    %throw(ME);
    InvSigma2 = [];
end

%sprintf ('FindBestInvSigma2s_Stabilizer found m=%i points', size(InvSigma2,1))
%sprintf ('FindBestInvSigma2s_Stabilizer finished after %8.3f seconds',  etime(clock,start_time))
end

function idx = FindRepeatedMax(point, max_points, max_count)
    idx = 0;
    nplus1 = size(max_points,2);
    for i=1:max_count
        if (norm (point - max_points(i,2:nplus1),inf) < 0.01)
            idx = i;
            break;
        end
    end
end

