%/***************************************************************************
% *   Copyright (C) 2010 by Kamaledin Ghiasi-Shirazi                        *
% *   ghiathi@gmail.com                                                     *
% *                                                                         *
% *   This program is free software; you can redistribute it and/or modify  *
% *   it under the terms of the GNU General Public License as published by  *
% *   the Free Software Foundation; either version 3 of the License, or     *
% *   (at your option) any later version.                                   *
% *                                                                         *
% *   This program is distributed in the hope that it will be useful,       *
% *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
% *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
% *   GNU General Public License for more details.                          *
% *                                                                         *
% *   You should have received a copy of the GNU General Public License     *
% *   along with this program; if not, write to the                         *
% *   Free Software Foundation, Inc.,                                       *
% *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
% ***************************************************************************/

function    InitializeDataset_Stabilizer(Path, dataset, trntstitr)
global trn tst 

trn = []; tst = [];   

if (strcmp(dataset,'usps_0-4,5-9') == 1)
    datasetpath = sprintf('%s/%s/', Path, 'usps');    
    load (sprintf('%susps_0-4,5-9', datasetpath));

elseif (strcmp(dataset,'mnistoe_60K') == 1)
    datasetpath = sprintf('%s/%s/', Path, 'mnist');    
    load (sprintf('%smnistoe_60K', datasetpath)); 

elseif (strcmp(dataset,'mnist38_60K') == 1)
    datasetpath = sprintf('%s/%s/', Path, 'mnist');    
    load (sprintf('%smnist38_60K', datasetpath)); 

elseif (strcmp(dataset,'mnist47_60K') == 1)
    datasetpath = sprintf('%s/%s/', Path, 'mnist');    
    load (sprintf('%smnist47_60K', datasetpath)); 

else
    datasetpath = sprintf('%s/%s/', Path, dataset);
    trndata  = load(sprintf('%s%s_train_data_%i.asc', datasetpath, dataset, trntstitr)); % load training data
    trnlabel = load(sprintf('%s%s_train_labels_%i.asc', datasetpath, dataset, trntstitr)); % load training data
    tstdata  = load(sprintf('%s%s_test_data_%i.asc', datasetpath, dataset, trntstitr)); % load training data
    tstlabel = load(sprintf('%s%s_test_labels_%i.asc', datasetpath, dataset, trntstitr)); % load training data

    trn.X = trndata';
    trn.y = trnlabel;
    
    tst.X = tstdata';
    tst.y = tstlabel;
end

trn.dim = size (trn.X,1);
trn.num_data = size (trn.X,2);

% Intitialize variables

trn.num_neg_data = size(find (trn.y == -1),1);
trn.num_pos_data = trn.num_data - trn.num_neg_data;
for i=1:trn.num_data
    if (trn.y(i) == 1)
        trn.sample_weights(i) = 1/trn.num_pos_data;
    else
        trn.sample_weights(i) = -1/trn.num_neg_data;
    end
end
trn.active_features = 1:trn.dim;    
trn.active_features_count = trn.dim;
trn.active_samples = 1:trn.num_data;    

tst.dim = size (tst.X,1);
tst.num_data = size (tst.X,2);


assert (size(trn.y,2) == 1);
assert (size(tst.y,2) == 1);

