%/***************************************************************************
% *   Copyright (C) 2010 by Kamaledin Ghiasi-Shirazi                        *
% *   ghiathi@gmail.com                                                     *
% *                                                                         *
% *   This program is free software; you can redistribute it and/or modify  *
% *   it under the terms of the GNU General Public License as published by  *
% *   the Free Software Foundation; either version 3 of the License, or     *
% *   (at your option) any later version.                                   *
% *                                                                         *
% *   This program is distributed in the hope that it will be useful,       *
% *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
% *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
% *   GNU General Public License for more details.                          *
% *                                                                         *
% *   You should have received a copy of the GNU General Public License     *
% *   along with this program; if not, write to the                         *
% *   Free Software Foundation, Inc.,                                       *
% *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
% ***************************************************************************/


function [numIters] = LocallyAdaptLBFGS (iteration)
        global m trn model Gamma Beta SVM_C Gamma_norm cteta steta
        global lmbfgs_M 
        global lmbfgs_max_iters_inner

        point = [sqrt(model.options.tau) ,model.options.rho];
        for i=1:m
            point(m+(i-1)*trn.dim+2 : m+i*trn.dim+1) = model.options.arg (:,i)';
        end        

        
        disp (sprintf ('Begin LocallyAdaptLBFGS time = %s', datestr(now)));
        t_begin = clock;

        [f alpha optimalPoint gradTemp numIters] = LocalAdaptInterface (trn.X, trn.active_features, point', ...
           Gamma_norm, Beta, lmbfgs_max_iters_inner, lmbfgs_M ,cteta, steta, trn.y',SVM_C, 0.0001, 0, 0.0001); 


        t_end = clock;
        disp (sprintf ('End LocallyAdaptLBFGS t= %i', etime (t_end, t_begin)));

        Gamma =[];
        j = 1;
        for i=1:m
            if optimalPoint(i+1) * optimalPoint(i+1) > epsm
                Gamma(j,:) = optimalPoint(m+1+(i-1)*trn.dim + 1: m+1+i*trn.dim);
                j = j + 1;
            end
        end
        m = j-1;
        if (m == 0)
            f = inf;
            return;
        end

%         disp ('Begin ReSolveQCQP');
%         t_begin = clock;
%         fCorrected = SolveCombinedQCQP (SVM_C);
%         t_end = clock;
%         sprintf ('End ReSolveQCQP t= %i', etime (t_end, t_begin))
%         sprintf ('Tau_LocalAdapt = %f\n', model.options.tau)        
%       
%         sprintf ('fCorrected = %f, f = %f, Tau = %f\n', fCorrected, f, model.options.tau)        
end


