%/***************************************************************************
% *   Copyright (C) 2010 by Kamaledin Ghiasi-Shirazi                        *
% *   ghiathi@gmail.com                                                     *
% *                                                                         *
% *   This program is free software; you can redistribute it and/or modify  *
% *   it under the terms of the GNU General Public License as published by  *
% *   the Free Software Foundation; either version 3 of the License, or     *
% *   (at your option) any later version.                                   *
% *                                                                         *
% *   This program is distributed in the hope that it will be useful,       *
% *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
% *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
% *   GNU General Public License for more details.                          *
% *                                                                         *
% *   You should have received a copy of the GNU General Public License     *
% *   along with this program; if not, write to the                         *
% *   Free Software Foundation, Inc.,
% *
% *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
% ***************************************************************************/

function TestUCI ()

global SVM_C Beta Gamma_norm lmbfgs_max_iters lmbfgs_M 
global ExperimentRepeat cTotalIter cRepeated maxIter1 epsilon_fine
global lmbfgs_max_iters_inner
global cTotalIterGaussian cRepeatedGaussian Eta

Path = '/home/user/work/Datasets';
%Path = 'C:\Program Files\MATLAB\R2008a\work\Datasets';    
logfilenamePrefix = '';

method = 'GaussianMixture';
%method = 'CosineMixture';
%method = 'CosineAndGaussianMixture';

CosineMixtureOptimalBeta            = [0.071759, 10.66908522, 1.56371902, 2.43222982, 0.68412718, 0.31763029, 0.80725634, 37.70581876, 0.35714286, 5.42857143, 0.08571429, 0.27142857, 4.28571429];
CosineAndGaussianMixtureOptimalBeta = [0.215277, 5.97468772 , 1.21970084, 1.89713926, 0.031623  , 0.24775163, 0.96870761, 22.62349126, 1.78571430, 9.77142857, 0.25714287, 2.85      , 5.14285715];

for datasetNo = 1:13
    
    ExperimentRepeat = 100;
    cTotalIter = 500;
    cRepeated  = 4;
    cTotalIterGaussian = 20;
    cRepeatedGaussian  = 4;
    Eta = 0.03;
    maxIter1   = 1000;
    epsilon_fine   = 0.001;
    lmbfgs_max_iters = 100;
    lmbfgs_max_iters_inner  = 20;
    lmbfgs_M = 17;
    Gamma_norm = 2;  % 1 or 2
    CVTime = inf;
    
    SVM_C = inf;
    Gamma_norm = 2;  % 1 or 2
    
    switch (datasetNo)
        case {1}
            dataset = 'banana';   
            %Beta    =  0.071759;       CosineMixture
            %Beta     =  0.21527700;    CosineAndGaussianMixture
        case {2}
            dataset = 'heart';   
            %Beta    =  10.66908522;    CosineMixture
            %Beta     =  5.97468772;    CosineAndGaussianMixture
        case {3}
            dataset = 'breast-cancer';
            %Beta    =  1.56371902;     CosineMixture
            %Beta     =  1.21970084;    CosineAndGaussianMixture
        case {4}
            dataset = 'german';            
            %Beta    = 2.43222982;      CosineMixture
            %Beta     = 1.89713926;     CosineAndGaussianMixture
        case {5}
            dataset = 'flare-solar';
            %Beta    =  0.68412718;     CosineMixture
            %Beta     =  0.031623;      CosineAndGaussianMixture
        case {6}
            dataset = 'titanic';
            %Beta    =  0.31763029;     CosineMixture
            %Beta     =  0.24775163;    CosineAndGaussianMixture
        case {7} 
            dataset = 'diabetis';
            %Beta    = 0.80725634;      CosineMixture
            %Beta     = 0.96870761;     CosineAndGaussianMixture
        case {8}
            dataset = 'twonorm'; 
            %Beta    =  37.70581876;    CosineMixture
            %Beta     =  22.62349126;   CosineAndGaussianMixture
        case {9}
            dataset = 'thyroid';
            %Beta    =  0.35714286;     CosineMixture
            %Beta     =  1.78571430;    CosineAndGaussianMixture
        case {10}
            dataset = 'waveform';           
            %Beta    =  5.42857143;     CosineMixture
            %Beta     =  9.77142857;    CosineAndGaussianMixture
        case {11}
            ExperimentRepeat = 20;
            dataset = 'image';
            %Beta    =  0.08571429;     CosineMixture
            %Beta    =  0.25714287;     CosineAndGaussianMixture
        case {12}
            dataset = 'ringnorm';
            %Beta    =  0.27142857;     CosineMixture
            %Beta    =  2.85;           CosineAndGaussianMixture
        case {13}
            ExperimentRepeat = 20;
            dataset = 'splice';
            %Beta    =  4.28571429;     CosineMixture
            %Beta    =  5.14285715;     CosineAndGaussianMixture
    end
    
    if (strcmp (method, 'CosineMixture'))
        Beta = CosineMixtureOptimalBeta(datasetNo);
    elseif (strcmp (method, 'CosineAndGaussianMixture'))
        Beta = CosineAndGaussianMixtureOptimalBeta(datasetNo);        
    end
    
    [tsterrMean tsterrStd tstTimeMean tstTimeStd trnerrMean trnerrStd trntimeMean ...
                    trntimeStd mCosineMean mCosineStd mGaussianMean mGaussianStd nsvMean nsvStd] = RunCombined( Path, dataset, logfilenamePrefix, method);

    out = sprintf ('dataset=%s\n Beta=%f\n CVTime=%f\n tsterrMean=%f\n tsterrStd=%f\n tstTimeMean%f\n tstTimeStd=%f\n trnerrMean=%f\n trnerrStd=%f\n trntimeMean=%f\n trntimeStd=%f\n mCosineMean=%f\n mCosineStd=%f\n mGaussianMean=%f\n mGaussianStd=%f\n nsvMean=%f\n nsvStd=%f\n', ...
        dataset, Beta, CVTime, tsterrMean ,tsterrStd ,tstTimeMean ,tstTimeStd ,trnerrMean ,trnerrStd ,trntimeMean ,trntimeStd ,mCosineMean, mCosineStd, mGaussianMean, mGaussianStd ,nsvMean ,nsvStd);
    
    display (out);
    
    inParams = sprintf ('ExperimentRepeat = %f\ncTotalIter = %f \ncRepeated  = %f\nmaxIter1 = %f \nepsilon_fine = %f\nlmbfgs_max_iters = %f\nlmbfgs_max_iters_inner = %f\nlmbfgs_M = %f\nGamma_norm = %f\n' ...
        ,ExperimentRepeat, cTotalIter,cRepeated ,maxIter1 ,epsilon_fine, lmbfgs_max_iters,lmbfgs_max_iters_inner, lmbfgs_M, Gamma_norm);
    fid = fopen(sprintf('%s%s%s',dataset , date,'(Final Result)'),'wt');
    fwrite(fid,inParams);
    fwrite(fid,out);
    fclose(fid);
end

