%Copyright (c) 2009, Peter Vincent Gehler
%All rights reserved.

%Redistribution and use in source and binary forms, with or without
%modification, are permitted provided that the following conditions
%are met:
%1. Redistributions of source code must retain the above copyright
%   notice, this list of conditions and the following disclaimer.
%2. Redistributions in binary form must reproduce the above copyright
%   notice, this list of conditions and the following disclaimer in the
%   documentation and/or other materials provided with the distribution.
%3. The name of the author may not be used to endorse or promote products
%   derived from this software without specific prior written permission.

%THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
%IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
%OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
%IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
%INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
%NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
%THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function D = dist_euclid(X1,X2,A)


if ~exist('A','var')

    X1X1 = (sum(X1.^2,2));
    if ~exist('X2','var') || numel(X2)==0
	D = ones(length(X1X1),1)*X1X1' + X1X1*ones(1,length(X1X1)) - 2*(X1*X1');
    else
	X2X2 = (sum(X2.^2,2));
	D = ones(length(X1X1),1)*X2X2' + X1X1*ones(1,length(X2X2)) - 2*(X1*X2');
    end
else
    X1X1 = (sum((X1*A).^2,2));
    
    if ~exist('X2','var') || numel(X2)==0
	X2X2 = X1X1;
    else
	X2X2 = (sum((X2*A).^2,2));
    end
    
    D = ones(length(X1X1),1)*X2X2' + X1X1*ones(1,length(X2X2)) - 2*(X1*A*X2');

end

